using System;
using System.ComponentModel;
using System.Xml.Serialization;

namespace Jerry.DroidBuilder.ThemeEditor.Layout
{
    public class Searchable : AndroidElement
    {
        [Category("Searchable")]
        [XmlAttribute(AttributeName = "icon", Namespace = "http://schemas.android.com/apk/res/android")]
        public Icon Icon { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "label", Namespace = "http://schemas.android.com/apk/res/android")]
        public string Label { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "hint", Namespace = "http://schemas.android.com/apk/res/android")]
        public string Hint { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "searchButtonText", Namespace = "http://schemas.android.com/apk/res/android")]
        public string SearchButtonText { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "inputType", Namespace = "http://schemas.android.com/apk/res/android")]
        public InputType InputType { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "imeOptions", Namespace = "http://schemas.android.com/apk/res/android")]
        public ImeOptions ImeOptions { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "searchMode", Namespace = "http://schemas.android.com/apk/res/android")]
        public SearchMode SearchMode { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "voiceSearchMode", Namespace = "http://schemas.android.com/apk/res/android")]
        public VoiceSearchMode VoiceSearchMode { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "voiceLanguageModel", Namespace = "http://schemas.android.com/apk/res/android")]
        public string VoiceLanguageModel { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "voicePromptText", Namespace = "http://schemas.android.com/apk/res/android")]
        public string VoicePromptText { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "voiceLanguage", Namespace = "http://schemas.android.com/apk/res/android")]
        public string VoiceLanguage { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "voiceMaxResults", Namespace = "http://schemas.android.com/apk/res/android")]
        public int VoiceMaxResults { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "searchSuggestAuthority", Namespace = "http://schemas.android.com/apk/res/android")]
        public string SearchSuggestAuthority { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "searchSuggestPath", Namespace = "http://schemas.android.com/apk/res/android")]
        public string SearchSuggestPath { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "searchSuggestSelection", Namespace = "http://schemas.android.com/apk/res/android")]
        public string SearchSuggestSelection { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "searchSuggestIntentAction", Namespace = "http://schemas.android.com/apk/res/android")]
        public string SearchSuggestIntentAction { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "searchSuggestIntentData", Namespace = "http://schemas.android.com/apk/res/android")]
        public string SearchSuggestIntentData { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "searchSuggestThreshold", Namespace = "http://schemas.android.com/apk/res/android")]
        public int SearchSuggestThreshold { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "includeInGlobalSearch", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool IncludeInGlobalSearch { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "queryAfterZeroResults", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool QueryAfterZeroResults { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "searchSettingsDescription", Namespace = "http://schemas.android.com/apk/res/android")]
        public string SearchSettingsDescription { get; set; }

        [Category("Searchable")]
        [XmlAttribute(AttributeName = "autoUrlDetect", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool AutoUrlDetect { get; set; }
    }
}
