using System;
using System.ComponentModel;
using System.Xml.Serialization;

namespace Jerry.DroidBuilder.ThemeEditor.Layout
{
    public class TextView : AndroidElement
    {
        [Category("TextView")]
        [XmlAttribute(AttributeName = "bufferType", Namespace = "http://schemas.android.com/apk/res/android")]
        public BufferType BufferType { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "text", Namespace = "http://schemas.android.com/apk/res/android")]
        public string Text { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "hint", Namespace = "http://schemas.android.com/apk/res/android")]
        public string Hint { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "textColor", Namespace = "http://schemas.android.com/apk/res/android")]
        public string TextColor { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "textColorHighlight", Namespace = "http://schemas.android.com/apk/res/android")]
        public string TextColorHighlight { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "textColorHint", Namespace = "http://schemas.android.com/apk/res/android")]
        public string TextColorHint { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "textAppearance", Namespace = "http://schemas.android.com/apk/res/android")]
        public string TextAppearance { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "textSize", Namespace = "http://schemas.android.com/apk/res/android")]
        public string TextSize { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "textScaleX", Namespace = "http://schemas.android.com/apk/res/android")]
        public double TextScaleX { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "typeface", Namespace = "http://schemas.android.com/apk/res/android")]
        public Typeface Typeface { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "textStyle", Namespace = "http://schemas.android.com/apk/res/android")]
        public TextStyle TextStyle { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "textColorLink", Namespace = "http://schemas.android.com/apk/res/android")]
        public string TextColorLink { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "cursorVisible", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool CursorVisible { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "maxLines", Namespace = "http://schemas.android.com/apk/res/android")]
        public int MaxLines { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "maxHeight", Namespace = "http://schemas.android.com/apk/res/android")]
        public string MaxHeight { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "lines", Namespace = "http://schemas.android.com/apk/res/android")]
        public int Lines { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "height", Namespace = "http://schemas.android.com/apk/res/android")]
        public string Height { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "minLines", Namespace = "http://schemas.android.com/apk/res/android")]
        public int MinLines { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "minHeight", Namespace = "http://schemas.android.com/apk/res/android")]
        public double MinHeight { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "maxEms", Namespace = "http://schemas.android.com/apk/res/android")]
        public int MaxEms { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "maxWidth", Namespace = "http://schemas.android.com/apk/res/android")]
        public string MaxWidth { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "ems", Namespace = "http://schemas.android.com/apk/res/android")]
        public int Ems { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "width", Namespace = "http://schemas.android.com/apk/res/android")]
        public string Width { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "minEms", Namespace = "http://schemas.android.com/apk/res/android")]
        public int MinEms { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "minWidth", Namespace = "http://schemas.android.com/apk/res/android")]
        public double MinWidth { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "gravity", Namespace = "http://schemas.android.com/apk/res/android")]
        public Gravity Gravity { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "scrollHorizontally", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool ScrollHorizontally { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "password", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool Password { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "singleLine", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool SingleLine { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "enabled", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool Enabled { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "selectAllOnFocus", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool SelectAllOnFocus { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "includeFontPadding", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool IncludeFontPadding { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "maxLength", Namespace = "http://schemas.android.com/apk/res/android")]
        public int MaxLength { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "shadowColor", Namespace = "http://schemas.android.com/apk/res/android")]
        public string ShadowColor { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "shadowDx", Namespace = "http://schemas.android.com/apk/res/android")]
        public double ShadowDx { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "shadowDy", Namespace = "http://schemas.android.com/apk/res/android")]
        public double ShadowDy { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "shadowRadius", Namespace = "http://schemas.android.com/apk/res/android")]
        public double ShadowRadius { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "autoLink", Namespace = "http://schemas.android.com/apk/res/android")]
        public AutoLink AutoLink { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "linksClickable", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool LinksClickable { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "numeric", Namespace = "http://schemas.android.com/apk/res/android")]
        public Numeric Numeric { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "digits", Namespace = "http://schemas.android.com/apk/res/android")]
        public string Digits { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "phoneNumber", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool PhoneNumber { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "inputMethod", Namespace = "http://schemas.android.com/apk/res/android")]
        public string InputMethod { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "capitalize", Namespace = "http://schemas.android.com/apk/res/android")]
        public Capitalize Capitalize { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "autoText", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool AutoText { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "editable", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool Editable { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "freezesText", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool FreezesText { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "ellipsize", Namespace = "http://schemas.android.com/apk/res/android")]
        public Ellipsize Ellipsize { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "drawableTop", Namespace = "http://schemas.android.com/apk/res/android")]
        public string DrawableTop { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "drawableBottom", Namespace = "http://schemas.android.com/apk/res/android")]
        public string DrawableBottom { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "drawableLeft", Namespace = "http://schemas.android.com/apk/res/android")]
        public string DrawableLeft { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "drawableRight", Namespace = "http://schemas.android.com/apk/res/android")]
        public string DrawableRight { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "drawablePadding", Namespace = "http://schemas.android.com/apk/res/android")]
        public string DrawablePadding { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "lineSpacingExtra", Namespace = "http://schemas.android.com/apk/res/android")]
        public string LineSpacingExtra { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "lineSpacingMultiplier", Namespace = "http://schemas.android.com/apk/res/android")]
        public double LineSpacingMultiplier { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "marqueeRepeatLimit", Namespace = "http://schemas.android.com/apk/res/android")]
        public int MarqueeRepeatLimit { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "inputType", Namespace = "http://schemas.android.com/apk/res/android")]
        public InputType InputType { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "imeOptions", Namespace = "http://schemas.android.com/apk/res/android")]
        public ImeOptions ImeOptions { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "privateImeOptions", Namespace = "http://schemas.android.com/apk/res/android")]
        public string PrivateImeOptions { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "imeActionLabel", Namespace = "http://schemas.android.com/apk/res/android")]
        public string ImeActionLabel { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "imeActionId", Namespace = "http://schemas.android.com/apk/res/android")]
        public int ImeActionId { get; set; }

        [Category("TextView")]
        [XmlAttribute(AttributeName = "editorExtras", Namespace = "http://schemas.android.com/apk/res/android")]
        public string EditorExtras { get; set; }
    }
}
