using System;
using System.ComponentModel;
using System.Xml.Serialization;

namespace Jerry.DroidBuilder.ThemeEditor.Layout
{
    public class View : AndroidElement
    {
        [Category("View")]
        [XmlAttribute(AttributeName = "id", Namespace = "http://schemas.android.com/apk/res/android")]
        public string Id { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "tag", Namespace = "http://schemas.android.com/apk/res/android")]
        public string Tag { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "scrollX", Namespace = "http://schemas.android.com/apk/res/android")]
        public string ScrollX { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "scrollY", Namespace = "http://schemas.android.com/apk/res/android")]
        public string ScrollY { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "background", Namespace = "http://schemas.android.com/apk/res/android")]
        public string Background { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "padding", Namespace = "http://schemas.android.com/apk/res/android")]
        public string Padding { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "paddingLeft", Namespace = "http://schemas.android.com/apk/res/android")]
        public string PaddingLeft { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "paddingTop", Namespace = "http://schemas.android.com/apk/res/android")]
        public string PaddingTop { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "paddingRight", Namespace = "http://schemas.android.com/apk/res/android")]
        public string PaddingRight { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "paddingBottom", Namespace = "http://schemas.android.com/apk/res/android")]
        public string PaddingBottom { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "focusable", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool Focusable { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "focusableInTouchMode", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool FocusableInTouchMode { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "visibility", Namespace = "http://schemas.android.com/apk/res/android")]
        public Visibility Visibility { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "fitsSystemWindows", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool FitsSystemWindows { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "scrollbars", Namespace = "http://schemas.android.com/apk/res/android")]
        public Scrollbars Scrollbars { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "scrollbarStyle", Namespace = "http://schemas.android.com/apk/res/android")]
        public ScrollbarStyle ScrollbarStyle { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "isScrollContainer", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool IsScrollContainer { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "fadeScrollbars", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool FadeScrollbars { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "scrollbarFadeDuration", Namespace = "http://schemas.android.com/apk/res/android")]
        public int ScrollbarFadeDuration { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "scrollbarDefaultDelayBeforeFade", Namespace = "http://schemas.android.com/apk/res/android")]
        public int ScrollbarDefaultDelayBeforeFade { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "scrollbarSize", Namespace = "http://schemas.android.com/apk/res/android")]
        public string ScrollbarSize { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "scrollbarThumbHorizontal", Namespace = "http://schemas.android.com/apk/res/android")]
        public string ScrollbarThumbHorizontal { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "scrollbarThumbVertical", Namespace = "http://schemas.android.com/apk/res/android")]
        public string ScrollbarThumbVertical { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "scrollbarTrackHorizontal", Namespace = "http://schemas.android.com/apk/res/android")]
        public string ScrollbarTrackHorizontal { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "scrollbarTrackVertical", Namespace = "http://schemas.android.com/apk/res/android")]
        public string ScrollbarTrackVertical { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "scrollbarAlwaysDrawHorizontalTrack", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool ScrollbarAlwaysDrawHorizontalTrack { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "scrollbarAlwaysDrawVerticalTrack", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool ScrollbarAlwaysDrawVerticalTrack { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "fadingEdge", Namespace = "http://schemas.android.com/apk/res/android")]
        public FadingEdge FadingEdge { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "fadingEdgeLength", Namespace = "http://schemas.android.com/apk/res/android")]
        public string FadingEdgeLength { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "nextFocusLeft", Namespace = "http://schemas.android.com/apk/res/android")]
        public string NextFocusLeft { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "nextFocusRight", Namespace = "http://schemas.android.com/apk/res/android")]
        public string NextFocusRight { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "nextFocusUp", Namespace = "http://schemas.android.com/apk/res/android")]
        public string NextFocusUp { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "nextFocusDown", Namespace = "http://schemas.android.com/apk/res/android")]
        public string NextFocusDown { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "clickable", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool Clickable { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "longClickable", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool LongClickable { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "saveEnabled", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool SaveEnabled { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "drawingCacheQuality", Namespace = "http://schemas.android.com/apk/res/android")]
        public DrawingCacheQuality DrawingCacheQuality { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "keepScreenOn", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool KeepScreenOn { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "duplicateParentState", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool DuplicateParentState { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "minHeight", Namespace = "http://schemas.android.com/apk/res/android")]
        public double MinHeight { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "minWidth", Namespace = "http://schemas.android.com/apk/res/android")]
        public double MinWidth { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "soundEffectsEnabled", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool SoundEffectsEnabled { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "hapticFeedbackEnabled", Namespace = "http://schemas.android.com/apk/res/android")]
        public bool HapticFeedbackEnabled { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "contentDescription", Namespace = "http://schemas.android.com/apk/res/android")]
        public string ContentDescription { get; set; }

        [Category("View")]
        [XmlAttribute(AttributeName = "onClick", Namespace = "http://schemas.android.com/apk/res/android")]
        public string OnClick { get; set; }
    }
}
