﻿using System.IO;

namespace Jerry.DroidBuilder.ThemeEditor
{
    public class NinePatchInfo
    {
        /// <summary>
        /// Gets or set image width.
        /// This information is not necessary for 9 patch info.
        /// It's here for easy access.
        /// </summary>
        public int ImageWidth { get; set; }

        /// <summary>
        /// Gets or sets image height.
        /// This information is not necessary for 9 patch info.
        /// It's here for easy access.
        /// </summary>
        public int ImageHeight { get; set; }

        public int PaddingLeft { get; private set; }

        public int PaddingRight { get; private set; }

        public int PaddingTop { get; private set; }

        public int PaddingBottom { get; private set; }

        public int[] HorizontalStretchableAreas { get; private set; }

        public int[] VerticalStretchableAreas { get; private set; }

        public NinePatchInfo(int padLeft, int padRight, int padTop, int padBottom, int[] horizontalAreas, int[] verticalAreas)
        {
            PaddingLeft = padLeft;
            PaddingRight = padRight;
            PaddingTop = padTop;
            PaddingBottom = padBottom;
            HorizontalStretchableAreas = horizontalAreas;
            VerticalStretchableAreas = verticalAreas;
        }
    }
}
